import QtQuick 2.0
import org.shotcut.qml 1.0

Metadata {
    type: Metadata.Filter
	objectName: 'Sniper_Scope'
    name: qsTr("SniperScope (HTML)")
    mlt_service: "webvfx"
    qml: "ui.qml"
    keyframes {
        allowAnimateIn: true
        allowAnimateOut: true
        simpleProperties: ['fp1', 'fp2', 'fp3', 'fp4']
        parameters: [
            Parameter {
                name: qsTr('X_pos')
                property: 'fp1'
                isSimple: true
                isCurve: true
                minimum: -1.0
                maximum:  2.0
            },
            Parameter {
                name: qsTr('Y_pos')
                property: 'fp2'
                isSimple: true
                isCurve: true
                minimum: -1.0
                maximum:  2.0
            },
            Parameter {
                name: qsTr('Diameter')
                property: 'fp3'
                isSimple: true
                isCurve: true
                minimum: 0.0
                maximum: 1.0
            },
            Parameter {
                name: qsTr('Magnification')
				property: 'fp4'
                isSimple: true
                isCurve: true
                minimum: 0.0
                maximum: 1.0
            }
        ]
    }
}
