/*
 * Copyright (c) 2014-2019 Meltytech, LLC
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
// KEYFRAMES to b added.

import QtQuick 2.1
import QtQuick.Controls 1.0
import QtQuick.Layouts 1.0
import Shotcut.Controls 1.0
 
//import QtQuick 2.1
//import QtQuick.Controls 1.1
//import QtQuick.Controls.Styles 1.1
//import QtQuick.Layouts  1.0
import QtQuick.Dialogs  1.0
//import Shotcut.Controls 1.0

Item {

/*
 uniform vec2  Scope_Coords;   //= vec2(0.5, 0.5);          // KF - Normalised coordinates of scope
 uniform float Scope_Diameter; //= 0.333;                   // KF - Normalises diameter of scope (1.0 = video height)
 uniform float Mag_Index;      //= 1.0;						// KF - Degree of magnification (0.0 to 1.0)
 uniform float Scope_Thickness;//= 0.04;					// Scope thickness fraction of scope diameter)
 uniform vec4  Scope_Color;    //= vec4(0.1, 0.1, 0.2, 1,0);// Colour of the scope    (normalised RGBA)
 uniform vec4  Reticule_Color; //= vec4(1.0, 0.0, 0.0, 1,0);// Colour of the reticule (normalised RGBA)
 uniform bool  Scope_Only;     //= false; 				    // true = only image within scope is shown
 uniform bool  Cross_Hairs;    //= true;					// true = scope cross-hairs are shown
*/

	Item {
		id:	fp1											// Formal Parameter 1
		property string	pname		: 'fp1'				// Formal Parameter name
		property string ptext		: 'X-pos'			// Formal Parameter title shown on filter
		property real   dflt		:  0.5				// Default value
		property var	mnmx		: [-100, 200]		// Scale [min, max]
		property real	slen		: mnmx[1] - mnmx[0]	// Scale length
		property var    sme			: [-1.0, 0.5, 2.0]	// min, average, max values
		property var    scale		: 100				// Scale is a percentage
		property var    stepsz		: 0.02				// stepSize (relative to Scale)
		property var    decplaces	: 2					// decimal places to display
	}
	Item {
		id:	fp2											// Formal Parameter 1
		property string	pname		: 'fp2'				// Formal Parameter name
		property string ptext		: 'Y-pos'			// Formal Parameter title shown on filter
		property real   dflt		: 0.5				// Default value
		property var	mnmx		: [-100, 200]		// Scale [min, max]
		property real	slen		: mnmx[1] - mnmx[0]	// Scale length
		property var    sme			: [-1.0, 0.5, 2.0]	// min, average, max values
		property var    scale		: 100				// Scale is a percentage
		property var    stepsz		: 0.02				// stepSize (relative to Scale)
		property var    decplaces	: 2					// decimal places to display
	}
	Item {
		id:	fp3											// Formal Parameter 1
		property string	pname		: 'fp3'				// Formal Parameter name
		property string ptext		: 'Diameter'		// Formal Parameter title shown on filter
		property real   dflt		: 0.333				// Default value
		property var	mnmx		: [0, 100]			// Scale [min, max]
		property real	slen		: mnmx[1] - mnmx[0]	// Scale length
		property var    sme			: [0.222, 0.333, 0.444]	// min, average, max values
		property var    scale		: 100				// Scale is a percentage
		property var    stepsz		: 1					// stepSize (relative to Scale)
		property var    decplaces	: 0					// decimal places to display
	}
	Item {
		id:	fp4											// Formal Parameter 1
		property string	pname		: 'fp4'				// Formal Parameter name
		property string ptext		: 'Magnification'	// Formal Parameter title shown on filter
		property real   dflt		: 1.0				// Default value
		property var	mnmx		: [0, 1]			// Scale [min, max]
		property real	slen		: mnmx[1] - mnmx[0]	// Scale length
		property var    sme			: [0.0, 0.5, 1.0]	// min, average, max values
		property var    scale		: 1					// Scale is NOT a percentage
		property var    stepsz		: 0.1				// stepSize (relative to Scale)
		property var    decplaces	: 1					// decimal places to display
	}
	Item {
		id:	fp5											// Formal Parameter 1
		property string	pname		: 'fp5'				// Formal Parameter name
		property string ptext		: 'Thickness'		// Formal Parameter title shown on filter
		property real   dflt		: 0.03				// Default value
		property var	mnmx		: [0, 100]			// Scale [min, max]
		property real	slen		: mnmx[1] - mnmx[0]	// Scale length
		property var    sme			: []				// min, average, max values
		property var    scale		: 100				// Scale is a percentage
		property var    stepsz		: 0.5				// stepSize (relative to Scale)
		property var    decplaces	: 1					// decimal places to display
	}
	Item {
		id:	fp6											// Formal Parameter 1
		property string	pname		: 'fp6'				// Formal Parameter name
		property string ptext		: 'Color'			// Formal Parameter title shown on filter
		property string dflt		: '#181830'			// Default value
	}
	Item {
		id:	fp7											// Formal Parameter 1
		property string	pname		: 'fp7'				// Formal Parameter name
		property string ptext		: 'Reticule color'	// Formal Parameter title shown on filter
		property string dflt		: '#ff0000'			// Default value
	}
	Item {
		id:	fp8											// Formal Parameter 1
		property string	pname		: 'fp8'				// Formal Parameter name
		property string ptext		: 'Cross-hairs'		// Formal Parameter title shown on filter
		property bool   dflt		: true				// Default value
	}
	Item {
		id:	fp9											// Formal Parameter 1
		property string	pname		: 'fp9'				// Formal Parameter name
		property string ptext		: 'Scope-only'		// Formal Parameter title shown on filter
		property bool   dflt		: false				// Default value
	}

    property bool	blockUpdate		: true
	
    property var	startValues		: [fp1.sme[0], fp2.sme[0], fp3.sme[0], fp4.sme[0]]	// KeyFrames: X-pos, Y_pos, Diameter, Magnification
    property var	middleValues	: [fp1.sme[1], fp2.sme[1], fp3.sme[1], fp4.sme[1]]
    property var	endValues		: [fp1.sme[2], fp2.sme[2], fp3.sme[2], fp4.sme[2]]
	
    width : 350
    height: 225
	
    Component.onCompleted: {
        if (filter.isNew) {
//	        filter.set('resource', filter.path + 'debug.html')
 			filter.set('resource', filter.path + 'Sniper_Scope.html')
			
            filter.set('fp1'	 , fp1.dflt)
            filter.set('fp2'	 , fp2.dflt)
            filter.set('fp3'	 , fp3.dflt)
            filter.set('fp4'	 , fp4.dflt)
            filter.set('fp5'	 , fp5.dflt)
            filter.set('fp6'	 , fp6.dflt)
            filter.set('fp7'	 , fp7.dflt)
            filter.set('fp8'	 , fp8.dflt)
            filter.set('fp9'	 , fp9.dflt)
			
            filter.savePreset(preset.parameters)
		} else {
            initSimpleAnimation()
		}
        setControls();
		setKeyframedControls();
//        filter.set('in' , producer.in)
//        filter.set('out', producer.out)
    }
	
	function initSimpleAnimation() {	// Key-framed formal parameters fp1 to fp4
		middleValues 	= [
						   filter.getDouble('fp1', filter.animateIn),
						   filter.getDouble('fp2', filter.animateIn),
                           filter.getDouble('fp3', filter.animateIn),
						   filter.getDouble('fp4', filter.animateIn)
						  ]
        if (filter.animateIn > 0) {
            startValues = [
						   filter.getDouble('fp1', 0),
						   filter.getDouble('fp2', 0),
						   filter.getDouble('fp3', 0),
						   filter.getDouble('fp4', 0)
						  ]
        }
        if (filter.animateOut > 0) {
            endValues 	= [
						   filter.getDouble('fp1', filter.duration - 1),
						   filter.getDouble('fp2', filter.duration - 1),
						   filter.getDouble('fp3', filter.duration - 1),
						   filter.getDouble('fp4', filter.duration - 1)
						  ]
        }
    }

    function getPosition() {
        return Math.max(producer.position - (filter.in - producer.in), 0)
    }

    function setKeyframedControls() {	// Key-framed
        var position	= getPosition()
        blockUpdate		= true
		
        fp1Slider.value = fp1Slider.minimumValue + filter.getDouble('fp1', position) * fp1.slen
        fp2Slider.value = fp2Slider.minimumValue + filter.getDouble('fp2', position) * fp2.slen
        fp3Slider.value = fp3Slider.minimumValue + filter.getDouble('fp3', position) * fp3.slen
        fp4Slider.value = fp4Slider.minimumValue + filter.getDouble('fp4', position) * fp4.slen
		
        blockUpdate	= false
        fp1Slider.enabled	= fp2Slider.enabled  = fp3Slider.enabled = fp4Slider.enabled
							= position <= 0                         ||
								(position >= (
											  filter.animateIn - 1) && position <= (filter.duration - filter.animateOut)
											 )                      ||
								 position >= (filter.duration - 1
								)
    }	
	
    function setControls() {		// Non-Key-framed
        var position        = getPosition()

        fp5Slider.value     = filter.getDouble('fp5') * fp5.scale
        fp6Swatch.value     = filter.get      ('fp6')
        fp7Swatch.value     = filter.get      ('fp7')
        fp8CheckBox.checked = filter.getDouble('fp8') != 0.0
        fp9CheckBox.checked = filter.getDouble('fp9') != 0.0
    }

    function updateFilter(parameter, value, position, button) {
        if (blockUpdate) return
        var index = preset.parameters.indexOf(parameter)
        if (position !== null) {
            if (position <= 0 && filter.animateIn > 0)
                startValues[index]	= value
            else if (position >= filter.duration - 1 && filter.animateOut > 0)
                endValues[index]	= value
            else
                middleValues[index]	= value
        }

        if (filter.animateIn > 0 || filter.animateOut > 0) {
            filter.resetProperty(parameter)
           button.checked = false
            if (filter.animateIn > 0) {
                filter.set(parameter,  startValues[index], 0)
                filter.set(parameter, middleValues[index], filter.animateIn - 1)
			}
            if (filter.animateOut > 0) {
                filter.set(parameter, middleValues[index], filter.duration - filter.animateOut)
                filter.set(parameter,    endValues[index], filter.duration - 1)
            }
        } else if (!button.checked) {
            filter.resetProperty(parameter)
            filter.set			(parameter, middleValues[index])
        } else if (position !== null) {
            filter.set			(parameter, value, position)
        }
   }

    function onKeyframesButtonClicked(checked, parameter, value) {
        if (checked) {
            blockUpdate = true
            fp1Slider.enabled = fp2Slider.enabled = fp3Slider.enabled = fp4Slider.enabled= true
            if (filter.animateIn > 0 || filter.animateOut > 0) {
                filter.resetProperty('fp1')
                filter.resetProperty('fp2')
                filter.resetProperty('fp3')
                filter.resetProperty('fp4')
				
                filter.animateIn = filter.animateOut = 0
            } else {
                filter.clearSimpleAnimation(parameter)
            }
            blockUpdate = false
            filter.set(parameter, value, getPosition())
        } else {
            filter.resetProperty(parameter)
            filter.set(parameter, value)
        }
    }

    GridLayout {
        columns			: 4
        anchors.fill	: parent
        anchors.margins	: 8

        Label {
            text: qsTr('Preset')
            Layout.alignment: Qt.AlignRight
        }

       Preset {
            id					: preset
            Layout.columnSpan	: parent.columns - 1
            parameters			: ['fp1', 'fp2', 'fp3', 'fp4', 'fp5', 'fp6', 'fp7', 'fp8', 'fp9']	
            onPresetSelected	: {
									setControls()
									setKeyframedControls()
									initSimpleAnimation()
			}
        }

        Label {
            text				: qsTr(fp1.ptext)		// X-pos (Key-framed)
            Layout.alignment	: Qt.AlignRight
        }
        SliderSpinner {
            id					: fp1Slider
			minimumValue		: fp1.mnmx[0]
            maximumValue		: fp1.mnmx[1]
			stepSize			: fp1.stepsz
			decimals			: fp1.decplaces
            suffix				: ' %'
            value				: minimumValue + filter.getDouble('fp1') * fp1.slen
            onValueChanged		: updateFilter('fp1', value / fp1.scale, getPosition(), fp1KeyframesButton)
        }
        UndoButton {
            onClicked			: fp1Slider.value = fp1Slider.minimumValue + fp1.dflt * fp1.slen
        }
        KeyframesButton {
            id					: fp1KeyframesButton
            checked				: filter.animateIn <= 0 && filter.animateOut <= 0 && filter.keyframeCount('fp1') > 0
            onToggled			: onKeyframesButtonClicked(checked, 'fp1', fp1Slider.value / fp1.scale)
        }

        Label {
            text				: qsTr(fp2.ptext)		// Y-pos (Key-framed)
            Layout.alignment	: Qt.AlignRight
        }
        SliderSpinner {
            id					: fp2Slider
			minimumValue		: fp2.mnmx[0]
            maximumValue		: fp2.mnmx[1]
			stepSize			: fp2.stepsz
			decimals			: fp2.decplaces
            suffix				: ' %'
            value				: minimumValue + filter.getDouble('fp2') * fp2.slen
            onValueChanged		: updateFilter('fp2', value / fp2.scale, getPosition(), fp2KeyframesButton)
        }
        UndoButton {
            onClicked			: fp2Slider.value = fp2Slider.minimumValue + fp2.dflt * fp2.slen
        }
        KeyframesButton {
            id					: fp2KeyframesButton
            checked				: filter.animateIn <= 0 && filter.animateOut <= 0 && filter.keyframeCount('fp2') > 0
            onToggled			: onKeyframesButtonClicked(checked, 'fp2', fp2Slider.value / fp2.scale)
        }

        Label {
            text				: qsTr(fp3.ptext)		// Diameter (Key-framed)
            Layout.alignment	: Qt.AlignRight
        }
        SliderSpinner {
            id					: fp3Slider
			minimumValue		: fp3.mnmx[0]
            maximumValue		: fp3.mnmx[1]
			stepSize			: fp3.stepsz
			decimals			: fp3.decplaces
            suffix				: ' %'
            value				: minimumValue + filter.getDouble('fp3') * fp3.slen
            onValueChanged		: updateFilter('fp3', value / fp3.scale, getPosition(), fp3KeyframesButton)
        }
        UndoButton {
            onClicked			: fp3Slider.value = fp3Slider.minimumValue + fp3.dflt * fp3.slen
        }
        KeyframesButton {
            id					: fp3KeyframesButton
            checked				: filter.animateIn <= 0 && filter.animateOut <= 0 && filter.keyframeCount('fp3') > 0
            onToggled			: onKeyframesButtonClicked(checked, 'fp3', fp3Slider.value / fp3.scale)
        }

        Label {
            text				: qsTr(fp4.ptext)		// Magnification (Key-framed)
            Layout.alignment	: Qt.AlignRight
        }
        SliderSpinner {
            id					: fp4Slider
			minimumValue		: fp4.mnmx[0]
            maximumValue		: fp4.mnmx[1]
			stepSize			: fp4.stepsz
			decimals			: fp4.decplaces
            value				: minimumValue + filter.getDouble('fp4') * fp4.slen
            onValueChanged		: updateFilter('fp4', value / fp4.scale, getPosition(), fp4KeyframesButton)
        }
        UndoButton {
            onClicked			: fp4Slider.value = fp4Slider.minimumValue + fp4.dflt * fp4.slen
        }
        KeyframesButton {
            id					: fp4KeyframesButton
            checked				: filter.animateIn <= 0 && filter.animateOut <= 0 && filter.keyframeCount('fp4') > 0
            onToggled			: onKeyframesButtonClicked(checked, 'fp4', fp4Slider.value / fp4.scale)
        }

        Label {
            text				: qsTr(fp5.ptext)		// Thickness (Non-Key-framed)
            Layout.alignment	: Qt.AlignRight
        }
        SliderSpinner {
            id					: fp5Slider
			minimumValue		: fp5.mnmx[0]
            maximumValue		: fp5.mnmx[1]
			stepSize			: fp5.stepsz
			decimals			: fp5.decplaces
            suffix				: ' %'
            value				: minimumValue + filter.getDouble('fp5') * fp5.slen
            onValueChanged		: filter.set('fp5', value / fp5.scale)
        }
        UndoButton {
            onClicked			:fp5Slider.value = fp5Slider.minimumValue + fp5.dflt * fp5.slen
        }
        Item { Layout.fillWidth	: true }

        Label {
            text					: qsTr(fp6.ptext)		// Color (Non-Key-framed)
            Layout.alignment		: Qt.AlignRight
        }
        ColorPicker {
            id						: fp6Swatch
            value					: filter.get('fp6')
            property bool isReady	: false
            Component.onCompleted	: isReady = true
            onValueChanged			: {
                if (isReady) {
                    filter.set('fp6'    , '' + value)
                    filter.set("disable", 0);
                }
            }
            onPickStarted			: filter.set("disable", 1)
            onPickCancelled			: filter.set('disable', 0)
        }
        UndoButton {
            onClicked				: fp6Swatch.value = fp6.dflt
        }
        Item { Layout.fillWidth		: true }

        Label {
            text					: qsTr(fp7.ptext)		// Reticule color (Non-Key-framed)
            Layout.alignment		: Qt.AlignRight
        }
        ColorPicker {
            id						: fp7Swatch
            value					: filter.get('fp7')
            property bool isReady	: false
            Component.onCompleted	: isReady = true
            onValueChanged			: {
                if (isReady) {
                    filter.set('fp7'    , '' + value)
                    filter.set("disable", 0);
                }
            }
            onPickStarted			: filter.set("disable", 1)
            onPickCancelled			: filter.set('disable', 0)
        }
        UndoButton {
            onClicked				: fp7Swatch.value = fp7.dflt
        }
        Item { Layout.fillWidth		: true }		
 
        Label {
            text					: qsTr('Option')		// Cross-hairs (Non-Key-framed)
            Layout.alignment		: Qt.AlignRight
        }
		CheckBox {
            id						: fp8CheckBox
            Layout.alignment		: Qt.AlignLeft
            checked					: filter.getDouble('fp8')
            text					: qsTr(fp8.ptext)
            onCheckedChanged		: filter.set('fp8', checked)
        }
		Label { text				: ' '  }
        Item  { Layout.fillWidth	: true }		
 
        Label {
            text					: qsTr('Option')		// Scope-only
            Layout.alignment		: Qt.AlignRight
        }
		CheckBox {
            id						: fp9CheckBox
            Layout.alignment		: Qt.AlignLeft
            checked					: filter.getDouble('fp9')
            text					: qsTr(fp9.ptext)
            onCheckedChanged		: filter.set('fp9', checked)
        }
		Label { text				: ' '  }
        Item  { Layout.fillWidth	: true }		
		
        Label {
            text					: qsTr('Description')		// Link to filter description
			Layout.alignment		: Qt.AlignRight
       }
		Button {
            id						: description
            Layout.alignment		: Qt.AlignLeft
			text					: "Details"
			onClicked				: Qt.openUrlExternally('http://elusien.co.uk/shotcut/filters/SniperScope')
        }		
        Item { Layout.fillWidth		: true }		
	}

    function updateSimpleAnimation() {
        updateFilter('fp1', fp1Slider.minimumValue + fp1Slider.value / fp1.scale, getPosition(), fp1KeyframesButton)
        updateFilter('fp2', fp2Slider.minimumValue + fp2Slider.value / fp2.scale, getPosition(), fp2KeyframesButton)
        updateFilter('fp3', fp3Slider.minimumValue + fp3Slider.value / fp3.scale, getPosition(), fp3KeyframesButton)
        updateFilter('fp4', fp4Slider.minimumValue + fp4Slider.value / fp4.scale, getPosition(), fp4KeyframesButton)
	}

    Connections {
        target				: filter
        onInChanged			: updateSimpleAnimation()
        onOutChanged		: updateSimpleAnimation()
        onAnimateInChanged	: updateSimpleAnimation()
        onAnimateOutChanged	: updateSimpleAnimation()
    }

    Connections {
        target				: producer
        onPositionChanged	: setKeyframedControls()
    }
}
